#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin >> n >> q;
    vector<int> p(n);
    vector<int>d(n);
    vector<int> b(q);
    vector<int> s(n,0);
    for(int i = 0; i < n; i++){
        cin >> d[i] >> p[i];

    }
    for(int j = 0; j < q;j++){
        cin >> b[j];
    }
    sort(d.begin(),d.end());
    s[0] = d[n-1];
    for(int i = 1; i < n; i++){
        s[i]=d[n-i-1]+s[i-1];
        
    }
    cout << '\n';
    for(int j = 0; j < q;j++){
        auto poz = lower_bound(s.begin(),s.end(),b[j]);
        if(poz == s.end()) cout << -1 <<'\n';
        else cout << poz-s.begin()+1<<'\n';
    }




    return 0;
}